/* Problem URL: https://codeforces.com/problemset/problem/1873/H */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

void solve()
{
    int n, a, b;
    cin >> n >> a >> b;
    a--, b--;

    vi dsu(n);
    rep(i, n) {
        dsu[i] = i;
    }

    function<int(int)> find_p = [&](int i) {
        if (dsu[i] == i) {
            return dsu[i];
        }
        return dsu[i] = find_p(dsu[i]);
    };

    auto join = [&](int a, int b) {
        a = find_p(a);
        b = find_p(b);
        dsu[b] = a;
        return a == b;
    };

    vi loop;
    pair<int, int> edge;

    vvi graph(n);
    rep(i, n) {
        int u, v;
        cin >> u >> v;
        u--, v--;

        if (!join(u, v)) {
            graph[u].push_back(v);
            graph[v].push_back(u);
            continue;
        }

        edge = {u, v};
    }

    vi depth(n, -1);
    vi parent(n);

    function<void(int, int)> dfs = [&](int i, int p) {
        depth[i] = depth[p] + 1;
        parent[i] = p;

        repv(j, graph[i]) {
            if (j == p) {
                continue;
            }

            dfs(j, i);
        }
    };

    dfs(0, 0);

    int u = edge.first;
    int v = edge.second;

    if (depth[u] > depth[v]) {
        swap(u, v);
    }

    int diff = depth[v] - depth[u];
    while (diff--) {
        loop.push_back(v);
        v = parent[v];
    }

    while (u != v) {
        loop.push_back(u);
        loop.push_back(v);

        u = parent[u];
        v = parent[v];
    }
    loop.push_back(u);

    graph[edge.first].push_back(edge.second);
    graph[edge.second].push_back(edge.first);

    vi disa(n, oo);
    vi disb(n, oo);

    auto bfs = [&](int ini, vi &dis) {
        dis[ini] = 0;
        queue<int> q;
        q.push(ini);

        while (!q.empty()) {
            auto i = q.front();
            q.pop();

            repv(j, graph[i]) {
                if (dis[j] > dis[i] + 1) {
                    dis[j] = dis[i] + 1;
                    q.push(j);
                }
            }
        }
    };

    bfs(a, disa);
    bfs(b, disb);

    repv(i, loop) {
        if (disa[i] > disb[i]) {
            cout << "YES\n";
            return;
        }
    }

    cout << "NO\n";
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
